#include <stdio.h>
#include <stdlib.h>

int main(int argc,char**argv) {
   FILE *f;
   long lf[1000];
   char str[80];
   int i,N;
   double DIV,MMIN,MMAX;

   if (argc!=5) {
      printf("Usage: %s <photometry file> <min mag> <max mag> <bins/mag>\n",*argv);
      exit(0);
   }
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   MMIN=atof(argv[2]);
   MMAX=atof(argv[3]);
   DIV=atof(argv[4]);
   N=(int)((MMAX-MMIN)*DIV+.5);
   if (N<=0) exit(0);
   for (i=0;i<N;i++) lf[i]=0;
   while (fgets(str,80,f)) {
      i=(int)((atof(str)-MMIN)*DIV+1)-1;
      if (i>=0 && i<N) lf[i]++;
   }
   fclose(f);
   for (i=0;i<N;i++) {
      printf("%5.2f %5.2f %5ld",MMIN+i/DIV,MMIN+(i+1)/DIV,lf[i]);
      if (i>0 && i<N-1) printf(" %5ld",-2*lf[i-1]+2*lf[i+1]);
      if (i>1 && i<N-2) printf(" %5ld",-2*lf[i-2]-lf[i-1]+lf[i+1]+2*lf[i+2]);
      printf("\n");
   }
   return 0;
}
