#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#ifdef LINUX
#include "linux.h"
#else
#include "sun.h"
#endif
typedef unsigned char byte;

int SCALE;
double mm[3][2],CSCALE;
float data[3][1600][1600];

#ifdef LINUX
#define lfwrite fwrite
#else
size_t lfwrite(const void*ptr,size_t l,size_t n,FILE*f) {
   char t[4];
   if (n==1 && l==2) {
      memcpy(t+0,ptr+1,1);
      memcpy(t+1,ptr+0,1);
   }
   else if (n==1 && l==4) {
      memcpy(t+0,ptr+3,1);
      memcpy(t+1,ptr+2,1);
      memcpy(t+2,ptr+1,1);
      memcpy(t+3,ptr+0,1);
   }
   else return fwrite(ptr,l,n,f);
   return fwrite(t,l,n,f);
}
#endif

#define ULIM 1.0
#define LLIM -2.0
void getsky(int img) {
   int cont=1;
   double av=0,sd=-1;
   while (cont) {
      int x,y,N=0;
      double t1=0,t2=0;
      for (x=0;x<1600;x++) for (y=0;y<1600;y++) if (data[img][x][y]!=0 && (sd<0 || (data[img][x][y]-av<=ULIM*sd && data[img][x][y]-av>=LLIM*sd))) {
	 t1+=data[img][x][y];
	 N++;
      }
      if (!N) return;
      t1/=N;
      for (x=0;x<1600;x++) for (y=0;y<1600;y++) if (data[img][x][y]!=0 && (sd<0 || (data[img][x][y]-av<=ULIM*sd && data[img][x][y]-av>=LLIM*sd))) t2+=(data[img][x][y]-t1)*(data[img][x][y]-t1);
      t2=sqrt(t1/N);
      cont=0;
      for (x=0;x<1600 && !cont;x++) for (y=0;y<1600 && !cont;y++) if (data[img][x][y]!=0 && (sd<0 || (data[img][x][y]-av<=ULIM*sd && data[img][x][y]-av>=LLIM*sd)) && (data[img][x][y]-t1>t2*ULIM || data[img][x][y]-t1<t2*LLIM)) cont=1;
      av=t1;
      sd=t2;
   }
   printf("Image %d: sky=%f +/- %f\n",img+1,av,sd);
}

void fakeg(double f1,double f2) {
   int x,y;
   double t;
   t=f1+f2;
   mm[1][0]=mm[0][0]*f1+mm[2][0]*f2;
   mm[1][1]=(mm[0][1]*f1+mm[2][1]*f2-mm[1][0])/t+mm[1][0];
   for (x=0;x<1600;x++) for (y=0;y<1600;y++) {
      if (data[0][x][y]<mm[0][0]) data[1][x][y]=0;
      else if (data[0][x][y]>mm[0][1]) data[1][x][y]=f1*mm[0][1];
      else data[1][x][y]=f1*data[0][x][y];
      if (data[2][x][y]<mm[2][0]) data[1][x][y]+=0;
      else if (data[2][x][y]>mm[2][1]) data[1][x][y]+=f2*mm[2][1];
      else data[1][x][y]+=f2*data[2][x][y];
   }
}

void cval(double in[3],byte out[3]) {
   double i0,i1,ii;
   int z;
   i0=ii=(in[0]+in[1]+in[2])/3.;
   if (i0<=0 || i0>=1) i0=i1=1.;
   else switch(SCALE) {
   case 1:i1=pow(i0,0.25); break;
   case 2:i1=pow(i0,0.333); break;
   case 3:i1=pow(i0,0.5); break;
   case 4:i1=log(i0*1000.+1.)/log(1001.); break;
   default:i1=i0; break;
   }
   for (z=0;z<3;z++) {
      in[z]=i1/i0*((in[z]-ii)*CSCALE+ii);
      if (in[z]<=0) out[z]=0;
      else if (in[z]>=1) out[z]=255;
      else out[z]=(byte)(in[z]*256);
   }
}

void reduce(byte bgr[3]) {
   /*
   //256-color grayscale;
   bgr[0]=bgr[1]=bgr[2]=(bgr[0]+bgr[1]+bgr[2]+1)/3;
   */
   /*
   //32-color grayscale;
   byte x;
   x=(bgr[0]+bgr[1]+bgr[2]+1)/3;
   x=x/8*8;
   bgr[0]=bgr[1]=bgr[2]=x;
   */
   /*
   //32-color color;
   bgr[0]=bgr[0]/8*8;
   bgr[1]=bgr[1]/8*8;
   bgr[2]=bgr[2]/8*8;
   */
}

void writebmp(char *fn) {
   FILE *f;
   int x,y,z,w=1600,h=1600;
   byte used[256][256][32];
   byte p2[8]={1,2,4,8,16,32,64,128};
   long nused=0;

   for (x=0;x<256;x++) for (y=0;y<256;y++) for (z=0;z<32;z++) used[x][y][z]=0;
   for (y=0;y<h;y++) for (x=0;x<w;x++) {
      byte bgr[3];
      double bgr0[3];
      for (z=0;z<3;z++) {
	 if (data[z][y][x]<=mm[z][0]) bgr0[z]=0.;
	 else if (data[z][y][x]>=mm[z][1]) bgr0[z]=1.;
	 else bgr0[z]=(data[z][y][x]-mm[z][0])/(mm[z][1]-mm[z][0]);
      }
      cval(bgr0,bgr);
      reduce(bgr);
      if (!(used[bgr[0]][bgr[1]][bgr[2]/32]&p2[bgr[2]%8])) nused++;
      used[bgr[0]][bgr[1]][bgr[2]/32]|=p2[bgr[2]%8];
   }
   printf("using %ld colors\n",nused);
   if ((f=fopen(fn,"wb"))==NULL) {
      printf("Cannot write %s\n",fn);
      exit(-1);
   }
   //header;
   {
      long l; short s;
      s=19778; lfwrite(&s,2,1,f); //file type ID;
      l=54+3*w*h; lfwrite(&l,4,1,f); //file size;
      s=0; lfwrite(&s,2,1,f); //reserved;
      s=0; lfwrite(&s,2,1,f); //reserved;
      l=54; lfwrite(&l,4,1,f); //header+info size;
   }
   //info;
   {
      long l; short s;
      l=40; lfwrite(&l,4,1,f); //size of section;
      lfwrite(&w,4,1,f); lfwrite(&h,4,1,f); //width & height;
      s=1; lfwrite(&s,2,1,f); //number of target planes;
      s=24; lfwrite(&s,2,1,f); //bits;
      l=0; lfwrite(&l,4,1,f); //compression;
      l=3*w*h; lfwrite(&l,4,1,f); //image bytes;
      l=0; lfwrite(&l,4,1,f); //X-pixels/meter (4000?);
      l=0; lfwrite(&l,4,1,f); //Y-pixels/meter (4000?);
      lfwrite(&nused,4,1,f); //used colors;
      lfwrite(&nused,4,1,f); //important colors;
   }
   for (y=0;y<h;y++) for (x=0;x<w;x++) {
      byte bgr[3];
      double bgr0[3];
      for (z=0;z<3;z++) {
	 if (data[z][y][x]<=mm[z][0]) bgr0[z]=0.;
	 else if (data[z][y][x]>=mm[z][1]) bgr0[z]=1.;
	 else bgr0[z]=(data[z][y][x]-mm[z][0])/(mm[z][1]-mm[z][0]);
      }
      cval(bgr0,bgr);
      reduce(bgr);
      fwrite(bgr,1,3,f);
   }
   fclose(f);
}

int ferr(FILE *f,char *str) {
   printf("****%s\n",str);
   fclose(f);
   return -1;
}

int main(int argc,char **argv) {
   int img,MODE,line,FAKEG=0;
   FILE *f;
   char str[81];

   if (argc!=13) {
      printf("Usage: %s <file min max> * bgr <output> <scale> <color scale>\n",*argv);
      printf("  scale: 0=linear, 1=sqrt, 2=**1/3, 3=**1/4, 4=log\n");
      printf("  color scale: 1.0 normally, 0.5 for UVI\n");
      return -1;
   }
   SCALE=atoi(argv[11]);
   CSCALE=atof(argv[12]);
   for (img=0;img<3;img++) {
      mm[img][0]=atof(argv[img*3+2]);
      mm[img][1]=atof(argv[img*3+3]);
      f=fopen(argv[1+img*3],"rb");
      if (f==NULL && img!=1) {
	 printf("**File %s not found\n",argv[img*3+1]);
	 return -1;
      }
      else if (f==NULL) FAKEG=1;
      else {
	 MODE=line=0;
	 while (!feof(f) && (!MODE || line%36)) {
	    fgets(str,81,f);
	    line++;
	    if (!MODE) {
	       if (!strncmp(str,"END     ",8)) MODE=1;
	       else if ((!strncmp(str,"SIMPLE  =",9)) && (str[29]!='T')) return ferr(f,"Illegal format type");
	       else if ((!strncmp(str,"BITPIX  =",9)) && (strncmp(str+27,"-32",3))) return ferr(f,"Illegal bits per pixel");
	       else if ((!strncmp(str,"NAXIS   =",9)) && (strncmp(str+27,"  2",3))) return ferr(f,"Illegal number of axes");
	       else if (!strncmp(str,"NAXIS",5)) {
		  int tmp;
		  tmp=atoi(str+9);
		  if (str[5]=='1' && tmp!=1600) return ferr(f,"Illegal X axis size");
		  else if (str[5]=='2' && tmp!=1600) return ferr(f,"Illegal Y axis size");
	       }
	    }
	 }
	 ffread(data[img],1600*1600,4,f);
	 getsky(img);
      }
   }
   if (FAKEG) fakeg(mm[1][0],mm[1][1]);
   writebmp(argv[10]);
   return 0;
}
